﻿InitSprite()

Enumeration
	#Window
	#Typeface
	#Sprite
EndEnumeration

IncludeFile "Typeface.pbi" : UseModule Typeface

OpenWindow(#Window, 0, 0, 700, 520, "Typeface Example", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(#Window), 0, 0, WindowWidth(#Window), WindowHeight(#Window), 0, 0, 0, #PB_Screen_NoSynchronization)
SpriteQuality(#PB_Sprite_BilinearFiltering)

UsePNGImageDecoder()
UsePNGImageEncoder()

;LoadTypeface(#Typeface, "xenon2.xml")
LoadTypeface(#Typeface, "Tahoma20.tf")

Define Time.f, Value.f, Value2.f, Text.s

Repeat
	
	Time.f = Mod(ElapsedMilliseconds()*0.0002, 1.0)
	Value.f = Sin(Time*2*#PI)
	Value2.f = Sin(Time*4*#PI)
	
	ClearScreen($000000)
	SpriteBlendingMode(#PB_Sprite_BlendSourceAlpha, #PB_Sprite_BlendInvertSourceAlpha)
	
	ResetTypefaceStyles(#Typeface)
	TypefaceAlignment(#Typeface, 0.0, 0.5)
	
	; Opacity and color
	DisplayTypeface(#Typeface, 10, 20, "Just display normal text")
	DisplayTypeface(#Typeface, 10, 50, "Text with an other opacity", 0.5+Value*0.25)
	DisplayTypeface(#Typeface, 10, 80, "Text with an other color", #Typeface_Ignore, RGB($A0+$50*Sin(Time*2*#PI), $A0+$50*Sin(Time*2*#PI+2), $A0+$50*Sin(Time*2*#PI+4)))
	
	; Italic with different inclination angles
	TypefaceItalic(#Typeface, 20*Value)
	DisplayTypeface(#Typeface, 10, 125, "Italic text with different inclination angles")
	TypefaceItalic(#Typeface, 0)
	
	; Size of the text
	TypefaceSize(#Typeface, Value*0.2+1.0)
	DisplayTypeface(#Typeface, 10, 170, "Smaller and larger text")
	TypefaceSize(#Typeface, 1.0)
	
	; Letter spacing
	TypefaceSpacing(#Typeface, 1+Value)
	DisplayTypeface(#Typeface, 10, 215, "Text with an other letter space")
	TypefaceSpacing(#Typeface, 0, 5+Value*5)
	DisplayTypeface(#Typeface, 10, 245, "Text with an other word space")
	TypefaceSpacing(#Typeface, 0, 0)
	
	; Unicode
	DisplayTypeface(#Typeface, 10, 290, "Гарнитура поддерживает unicode")
	DisplayTypeface(#Typeface, 10, 320, "Γραφή υποστηρίζει unicode")
	
	
	; Rotation
	TypefaceAlignment(#Typeface, 0.5, 0.5)
	TypefaceRotation(#Typeface, 20*Value)
	DisplayTypeface(#Typeface, 400, 50, "Z-axis rotated text")
	TypefaceRotation(#Typeface, 0, Time*360)
	DisplayTypeface(#Typeface, 600, 30, "Y-axis rotated text")
	TypefaceRotation(#Typeface, 0, 0, Time*360)
	DisplayTypeface(#Typeface, 600, 70, "X-axis rotated text")
	TypefaceRotation(#Typeface, 0)
	
	; Bend radius
	If Time <> 0
		TypefaceBendRadius(#Typeface, 150/Value)
	EndIf
	DisplayTypeface(#Typeface, 550, 140, "Or with a bend radius")
	TypefaceBendRadius(#Typeface, 0)
	
	; Kerning
	TypefaceAlignment(#Typeface, 0.0, 0.5)
	TypefaceKerning(#Typeface, #False)
	DisplayTypeface(#Typeface, 400, 215, "AV LT Te F. (kerning disabled)")
	TypefaceKerning(#Typeface, #True)
	DisplayTypeface(#Typeface, 400, 245, "AV LT Te F. (kerning enabled)")
	
	; Word wrap
	TypefaceAlignment(#Typeface, 0.0, 0.0)
	TypefaceWordWrap(#Typeface, 240+60*Value)
	Text = "Typeface supports line break characters like LF"+#LF$+"and also automatic word wrap."
	DisplayTypeface(#Typeface, 460-60*Value, 280, Text)
	TypefaceWordWrap(#Typeface, 300)
	
	; Region display
	TypefaceClipping(#Typeface, #True, 440-Value*50, 420+10*Value2, 180, 80-20*Value2)
	DisplayTypeface(#Typeface, 400, 410, "Clipped text inside a defined region - Clipped text inside a defined region - Clipped text inside a defined region")
	TypefaceClipping(#Typeface, #False)
	
	; Various styles together
	ResetTypefaceStyles(#Typeface)
	TypefaceOrigin(#Typeface, 0, 0, 1000)
	TypefaceAlignment(#Typeface, 0.5+Value*0.2, 0.5)
	TypefaceItalic(#Typeface, 20*Value)
	TypefaceSpacing(#Typeface, 1+Value2*1)
	TypefaceRotation(#Typeface, 20*Value, 40*Value2)
	If Time <> 0
		TypefaceBendRadius(#Typeface, 300/Value)
	EndIf
	DisplayTypeface(#Typeface, 240, 430, "Combine various styles together", #Typeface_Ignore, RGB($A0+$50*Sin(Time*2*#PI), $A0+$50*Sin(Time*2*#PI+2), $A0+$50*Sin(Time*2*#PI+4)))
	
	
	FlipBuffers()
	
Until WindowEvent() = #PB_Event_CloseWindow
; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 17
; FirstLine = 47
; Folding = -
; EnableXP
; EnableCompileCount = 163
; EnableBuildCount = 0
; EnableUnicode